#include <reg52.h>
					   
#define uchar unsigned char	 

uchar code table[] = "Write:";
uchar code table2[] = "Read :";
uchar code write_data[] = "World";

sbit port_rs = P3 ^ 4;  ///ѡˣ1ݣ0״̬
sbit port_rw = P3 ^ 5;	//дƣ1Ƕ0д
sbit port_en = P3 ^ 6;	//ʹܶˣߵƽ

sbit scl = P1 ^ 0;
sbit sda = P1 ^ 1;

void delay(uchar t);
void set_lcd(uchar val);
void set_data(uchar dat);
void write_at_addr(uchar addr,uchar dat);
uchar read_at_addr(uchar addr);
void init();
void delay_us();

void main()
{
	uchar i;
	init();

	set_lcd(0x80);//λΪһеһλ
	for(i=0;i<6;i++)
		set_data(table[i]);

	set_lcd(0x80+0x40);//λõڶеһλ	 
	for(i=0;i<6;i++)
		set_data(table2[i]);

	delay(5);

	/*оƬдַLXJٴоƬȡͬʱʾҺ*/
	for(i=0;*(write_data+i)!='\0';i++)
	{
		set_lcd(0x80+6+i+1);
		set_data(*(write_data+i));	
		write_at_addr(i+1,*(write_data+i));
	
		set_lcd(0x80+0x40+6+i+1);
		set_data( read_at_addr(i+1) );
	}

	//ʽҪںʱ
	/*set_lcd(0x80+7);
	set_data('H');	
	set_data('e');
	set_data('l');
	set_data('l');
	set_data('o');
	write_at_addr(1,'H'); delay(5); 
	write_at_addr(2,'e'); delay(5);
	write_at_addr(3,'l'); delay(5);
	write_at_addr(4,'l'); delay(5);
	write_at_addr(5,'o'); delay(5);

	set_lcd(0x80+0x40+7);
	set_data( read_at_addr(1) );  
	set_data( read_at_addr(2) );
	set_data( read_at_addr(3) );
	set_data( read_at_addr(4) );
	set_data( read_at_addr(5) ); */

	while(1);
}

void init()
{	
	//Һ
	set_lcd(0x38);//16*12ʾ5*78λݽӿ
	set_lcd(0x0c);//ÿʾʾ
	set_lcd(0x06);//дһַַָ1
	set_lcd(0x01);//ʾ0ָ0
	set_lcd(0x0f);//ʾ꣬ù˸

	//I2CоƬ
	sda = 1;
	delay_us();
	scl = 1;
	delay_us();
}

/*********************************Һ***********************************/
//ʱ
void delay(uchar t)
{				 
	uchar i,j; 
	for(i=0;i<t;i++)
		for(j=0;j<110;j++)
			;
}

//Һ
void set_lcd(uchar val)
{
	port_rs = 0;//ó
	delay(1);
	port_rw = 0;
	delay(1);
	port_en = 1;
	delay(1);
	P2 = val;//
	delay(5);
	port_en = 0;
}

//Һ
void set_data(uchar dat)
{	   
	port_rs = 1;//ó
	delay(1);
	port_rw = 0;
	delay(1);
	port_en = 1;
	delay(1);
	P2 = dat;//
	delay(5);
	port_en = 0;
}

/*****************************************洢оƬ********************************/
//ʱ4-5΢
void delay_us()
{
	;;;
}

//ʼ
void start()
{
	sda = 1;
	delay_us();
	scl = 1;
	delay_us();
	sda = 0;
	delay_us();		
}

//
void stop()
{
	sda = 0;
	delay_us();
	scl = 1;
	delay_us();
	sda = 1;
	delay_us();
}

//ȴӦ
void respons()
{
	uchar i;
	scl = 1;
	delay_us();

	while((sda==1) && (i<250))
		i++;
		
	scl = 0;
	delay_us(); 
}

//д
void write_byte(uchar dat)
{
	uchar i,temp;
	temp = dat;
	for(i=0;i<8;i++)
	{
		temp = temp << 1;
		scl = 0;
		delay_us();
		sda = CY;
		delay_us();
		scl = 1;
		delay_us();
	}

	scl = 0;
	delay_us();
	sda = 1;
	delay_us();
}

//
uchar read_byte()
{
	uchar i,k;
	scl = 0;
	delay_us();
	sda = 1;
	delay_us();
	for(i=0; i<8; i++)
	{
		scl = 1;
		delay_us();
		k = (k<<1) | sda;
		scl = 0;
		delay_us();
	}
	return k;
}

//оƬַָд
void write_at_addr(uchar addr,uchar dat)
{
	start();
	//趨ַAT24C02̶ַΪ1010ټ趨ĵַ
	//Ϊ000һλʾд0ʾдΪ1010 00000xa0
	write_byte(0xa0);
	respons();//ȴоƬӦ
	write_byte(addr);//Ҫдݵĵַ
	respons();//ȴоƬӦ
	write_byte(dat);//дҪ
	respons();//ȴоƬӦ
	stop();
}

//ȡоƬַָ
uchar read_at_addr(uchar addr)
{
	uchar dat;
	start();
	write_byte(0xa0);//оƬһдź
	respons();
	write_byte(addr);//Ҫȡĵַ
	respons();
	start();
	write_byte(0xa1);//оƬһź
	respons();
	dat = read_byte();
	stop();
	return dat;
}